/**************************************
 * NOTE: This source code is free and 
 * comes with ABSOLUTELY NO WARRANTY.
 * 
 * @author Daniel Muenter, 2006
 * 
 **************************************/

var FbfOptions = {
	
	prefs : Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService),
	http_request : null,
	devnotes : null,
	
	setVersion: function() {
		window.document.getElementById("fbf_version").value = "Feedbackfox "
				+ this.prefs.getCharPref("extensions.feedbackfox.version");
	},

	reset: function() {
		// set version number
		this.setVersion();
		// load developer notes
		this.setDevNotes();
		// set the initial state of the "showfbftbarbutton" checkbox
		window.document.getElementById("showfbftbarbutton").checked = this.prefs
				.getBoolPref("extensions.feedbackfox.showfbftbarbutton");
		// set the initial state of the "maxfeedbackcount" textfield
		window.document.getElementById("maxfeedbackcount").value = this.prefs
				.getCharPref("extensions.feedbackfox.maxfeedbackcount");
		// set the initial state of the characteristic
		var characteristic = this.prefs.getCharPref("extensions.feedbackfox.characteristic");
		var sellbuy = window.document.getElementById("sellbuy");
		var name = window.document.getElementById("name");
		sellbuy.removeAttribute("selected");
		name.removeAttribute("selected");
		if (characteristic == 'sellbuy') {
			sellbuy.setAttribute("selected", "true");
		} else {
			name.setAttribute("selected", "true");
		}
	},

	onAccept: function() {
		// set showfbftbarbutton
		this.prefs.setBoolPref("extensions.feedbackfox.showfbftbarbutton",
				window.document.getElementById("showfbftbarbutton").checked);
		// set maxfeedbackcount
		this.prefs.setCharPref("extensions.feedbackfox.maxfeedbackcount",
				window.document.getElementById("maxfeedbackcount").value);
		// set characteristic
		var index = window.document.getElementById("characteristic").selectedIndex;
		if (index == 0) {
			this.prefs.setCharPref("extensions.feedbackfox.characteristic", "sellbuy")
		} else {
			this.prefs.setCharPref("extensions.feedbackfox.characteristic", "name")
		}
		// close the window.
		window.close();
	},

	onCancel: function() {
		// close the window.
		window.close();
	},

	setDevNotes: function() {
		// request current developer notes
		this.devnotes = window.document.getElementById('devnotes');
		this.devnotes.value = "get developer notes...";
		this.getDevNotes('http://feedbackfox.mozdev.org/devnotes.txt');
	},

	getDevNotes: function(href) {

		this.http_request = new XMLHttpRequest();
		this.http_request.timeout = 3; // 3 seconds
		this.http_request.onreadystatechange = this.processDevNotes;
		this.http_request.open('GET', href, true);
		this.http_request.send(null);
	},

	processDevNotes: function() {
		var currentContent = "";
		if (FbfOptions.http_request.readyState == 4) {
			if (FbfOptions.http_request.status == 200) {
				var tmp = FbfOptions.http_request.responseText;
				tmp = tmp.replace(/<.*>\s*/, "");
				FbfOptions.devnotes.value = tmp;
			}
		}
	},

	runInFirefox: function(path) {
		var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
		var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
		var win = windowManagerInterface.getMostRecentWindow("navigator:browser");

		if (win) {
			var theTab = win.gBrowser.addTab(path);
			win.gBrowser.selectedTab = theTab;
			return;
		}
	}
};

